<?php
/**
 *
 *
 * @package 
 * @author     Ole Jungclaussen
 * @version    0.9.0
 * @.copyright 2021, Ole Jungclaussen
 */
require_once('PHP-Source-Query-2.1.0/SourceQuery.php');
require_once('PHP-Source-Query-2.1.0/BaseSocket.php');
require_once('PHP-Source-Query-2.1.0/bootstrap.php');
require_once('PHP-Source-Query-2.1.0/Buffer.php');
require_once('PHP-Source-Query-2.1.0/GoldSourceRcon.php');
require_once('PHP-Source-Query-2.1.0/Socket.php');
require_once('PHP-Source-Query-2.1.0/SourceQuery.php');
require_once('PHP-Source-Query-2.1.0/SourceRcon.php');
/**
 * A Server running Cliffs Of Dover
 */
class CClodServer {
// ########## PUBLIC PROPERTIES
    /**
     * 
     * @var bool
     */
    public bool $bPrintDiagnostics = false;
    /**
     * 
     * @var string
     */
    public ?string $sIp   = null;
    /**
     * 
     * @var string
     */
    public ?string $sPort = null;
    /**
     *  [Protocol] => 17 
     *  [HostName] => DangerDogz - All Welcome! 
     *  [Map] => English_Channel_1940 
     *  [ModDir] => cliffsofdover 
     *  [ModDesc] => Cliffs of Dover 
     *  [AppID] => 0 
     *  [Players] => 1 
     *  [MaxPlayers] => 44 
     *  [Bots] => 0 
     *  [Dedicated] => d 
     *  [Os] => w 
     *  [Password] => 
     *  [Secure] => 1 
     *  [Version] => 4.5.3.0 
     *  [ExtraDataFlags] => 177 
     *  [GamePort] => 27016 
     *  [ServerID] => 127902730 
     *  [GameTags] => $(defaultRV?k$!!!!!"Mg00+ 
     *  [GameID] => 754530 
     *  @var array
     */
    public array $aRawInfo = [];
    /**
     * Server's name.
     * @var string
     */
    public ?string $sHostName = null;
    /**
     * Players on Server.
     * @var array
     */
    public array $aPlayers = [];
    /**
     * Number of Players on Server.
     * @var int
     */
    public int $nPlayers = 0;
// ########## PROTECTED PROPERTIES
// ########## PRIVATE PROPERTIES
// ########## CONSTRUCTOR
    /**
     * 
     * @param string $sIp 
     * @param string $sPort 
     * @return void 
     */
    function __construct(string $sIp, string $sPort)
    {
        $this->sIp   = $sIp;
        $this->sPort = $sPort;
    }
    /**
     *
     *
     */
    function __destruct()
    {
        
    }
// ########## METHOD PUBLIC
    /**
     * 
     * @return bool 
     */
    public function queryInfo() : bool
    {
        if($this->bPrintDiagnostics)
        {
            print 'Querying '.$this->sIp.':'.$this->sPort.'</br>';
        }

        try {
            $Query = new xPaw\SourceQuery\SourceQuery();
            $Query->Connect($this->sIp, $this->sPort, 1, xPaw\SourceQuery\SourceQuery :: SOURCE );
            $this->aRawInfo = $Query->GetInfo();
            if($this->bPrintDiagnostics)
            {
                print_r($this->aRawInfo);
            }
        }
        catch(Exception $e)
        {
            if($this->bPrintDiagnostics)
            {
                print 'QUERY FAILURE['.$e->getMessage().']'.PHP_EOL;
            }
            return false;
        }
        
        $this->sHostName = trim($this->aRawInfo['HostName']);
        if(empty($this->sHostName)) $this->sHostName = 'unknown';
        
        if(true==$this->bPrintDiagnostics)
        {
            print '    Hostname: '.$this->sHostName.'<br>';
        }
        
        $this->aPlayers = array();
        $this->nPlayers = 0;
        
        $aTmpPlayers = $Query->GetPlayers();
        
        if(true==$this->bPrintDiagnostics)
        {
            print '    Players : '.strval(count($aTmpPlayers)).'<br>';
        }
        
        if(is_array($aTmpPlayers))
        {
            foreach($aTmpPlayers as $aPlayer)
            {
                $sName = trim($aPlayer['Name']);
                if(empty($sName)) $sName = 'empty_string_user';
                $this->aPlayers[] = $sName;
                $this->nPlayers++;
                if(true==$this->bPrintDiagnostics)
                {
                    print '              * '.$sName.'<br>';
                }
            }
        }

        if(true==$this->bPrintDiagnostics)
        {
            print '<br>';
        }
        return true;
    }
// ########## METHOD PROTECTED
// ########## METHOD PRIVATE
};